diff --git a/gcc/analyzer/infinite-loop.cc b/gcc/analyzer/infinite-loop.cc
index a53807c2ddb..f636ceb2b99 100644
--- a/gcc/analyzer/infinite-loop.cc
+++ b/gcc/analyzer/infinite-loop.cc
@@ -42,6 +42,8 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/checker-path.h"
 #include "analyzer/feasible-graph.h"
 
+#if 1
+
 /* A bundle of data characterizing a particular infinite loop
    identified within the exploded graph.  */
 
@@ -108,8 +110,9 @@ class perpetual_start_cfg_edge_event : public start_cfg_edge_event
 {
 public:
   perpetual_start_cfg_edge_event (const exploded_edge &eedge,
-				  const event_loc_info &loc_info)
-  : start_cfg_edge_event (eedge, loc_info)
+				  const event_loc_info &loc_info,
+				  const control_flow_op *op)
+  : start_cfg_edge_event (eedge, loc_info, op)
   {
   }
 
@@ -119,10 +122,12 @@ public:
     label_text edge_desc (m_sedge->get_description (user_facing));
     if (user_facing)
       {
-	if (edge_desc.get () && strlen (edge_desc.get ()) > 0)
+	if (edge_desc.get ()
+	    && strlen (edge_desc.get ()) > 0
+	    && m_op)
 	  {
 	    label_text cond_desc
-	      = maybe_describe_condition (pp_show_color (&pp));
+	      = m_op->maybe_describe_condition (pp_show_color (&pp));
 	    if (cond_desc.get ())
 	      pp_printf (&pp,
 			 "%s: always following %qs branch...",
@@ -143,8 +148,9 @@ class looping_back_event : public start_cfg_edge_event
 {
 public:
   looping_back_event (const exploded_edge &eedge,
-		      const event_loc_info &loc_info)
-  : start_cfg_edge_event (eedge, loc_info)
+		      const event_loc_info &loc_info,
+		      const control_flow_op *op)
+  : start_cfg_edge_event (eedge, loc_info, op)
   {
   }
 
@@ -189,8 +195,8 @@ public:
     return ctxt.warn ("infinite loop");
   }
 
-  bool maybe_add_custom_events_for_superedge (const exploded_edge &,
-					      checker_path *)
+  bool maybe_add_custom_events_for_eedge (const exploded_edge &,
+					  checker_path *)
     final override
   {
     /* Don't add any regular events; instead we add them after pruning as
@@ -235,9 +241,8 @@ public:
 	if (!eedge->m_sedge)
 	  continue;
 
-	const cfg_superedge *cfg_sedge
-	  = eedge->m_sedge->dyn_cast_cfg_superedge ();
-	if (!cfg_sedge)
+	::edge cfg_edge = eedge->m_sedge->get_any_cfg_edge ();
+	if (!cfg_edge)
 	  continue;
 
 	const exploded_node *src_node = eedge->m_src;
@@ -246,63 +251,73 @@ public:
 	const program_point &dst_point = dst_node->get_point ();
 	const int src_stack_depth = src_point.get_stack_depth ();
 	const int dst_stack_depth = dst_point.get_stack_depth ();
-	const gimple *last_stmt = src_point.get_supernode ()->get_last_stmt ();
-
 	event_loc_info loc_info_from
-	  (last_stmt ? last_stmt->location : cfg_sedge->get_goto_locus (),
+	  (src_point.get_supernode ()->get_location (),
 	   src_point.get_fndecl (),
 	   src_stack_depth);
 	event_loc_info loc_info_to
-	  (dst_point.get_supernode ()->get_start_location (),
+	  (dst_point.get_supernode ()->get_location (),
 	   dst_point.get_fndecl (),
 	   dst_stack_depth);
-
-	if (const switch_cfg_superedge *switch_cfg_sedge
-	      = cfg_sedge->dyn_cast_switch_cfg_superedge ())
-	  {
-	    if (switch_cfg_sedge->implicitly_created_default_p ())
-	      {
-		emission_path->add_event
-		  (std::make_unique<perpetual_start_cfg_edge_event>
+	if (auto base_op = eedge->m_sedge->get_op ())
+	  if (auto control_flow_op = base_op->dyn_cast_control_flow_op ())
+	    {
+	      if (control_flow_op->get_kind () == operation::switch_edge)
+		{
+		  const switch_case_op &case_op
+		    = *(const switch_case_op *)base_op;
+		  if (case_op.implicitly_created_default_p ())
+		    {
+		      emission_path->add_event
+			(std::make_unique<perpetual_start_cfg_edge_event>
+			 (*eedge,
+			  loc_info_from,
+			  control_flow_op));
+		      emission_path->add_event
+			(std::make_unique<end_cfg_edge_event>
+			 (*eedge,
+			  loc_info_to,
+			  control_flow_op));
+		    }
+		}
+	      else if (cfg_edge->flags & EDGE_TRUE_VALUE)
+		{
+		  emission_path->add_event
+		    (std::make_unique<perpetual_start_cfg_edge_event>
 		     (*eedge,
-		      loc_info_from));
-		emission_path->add_event
-		  (std::make_unique<end_cfg_edge_event>
+		      loc_info_from,
+		      control_flow_op));
+		  emission_path->add_event
+		    (std::make_unique<end_cfg_edge_event>
 		     (*eedge,
-		      loc_info_to));
-	      }
-	  }
+		      loc_info_to,
+		      control_flow_op));
+		}
+	      else if (cfg_edge->flags & EDGE_FALSE_VALUE)
+		{
+		  emission_path->add_event
+		    (std::make_unique<perpetual_start_cfg_edge_event>
+		     (*eedge,
+		      loc_info_from,
+		      control_flow_op));
+		  emission_path->add_event
+		    (std::make_unique<end_cfg_edge_event>
+		     (*eedge,
+		      loc_info_to,
+		      control_flow_op));
+		}
+	    }
 
-	if (cfg_sedge->true_value_p ())
-	  {
-	    emission_path->add_event
-	      (std::make_unique<perpetual_start_cfg_edge_event>
-		 (*eedge,
-		  loc_info_from));
-	    emission_path->add_event
-	      (std::make_unique<end_cfg_edge_event>
-		 (*eedge,
-		  loc_info_to));
-	  }
-	else if (cfg_sedge->false_value_p ())
-	  {
-	    emission_path->add_event
-	      (std::make_unique<perpetual_start_cfg_edge_event>
-		 (*eedge,
-		  loc_info_from));
-	    emission_path->add_event
-	      (std::make_unique<end_cfg_edge_event>
-		 (*eedge,
-		  loc_info_to));
-	  }
-	else if (cfg_sedge->back_edge_p ())
+	if (cfg_edge->flags & EDGE_DFS_BACK)
 	  {
 	    emission_path->add_event
-	      (std::make_unique<looping_back_event> (*eedge, loc_info_from));
+	      (std::make_unique<looping_back_event> (*eedge, loc_info_from,
+						     nullptr));
 	    emission_path->add_event
 	      (std::make_unique<end_cfg_edge_event>
 		 (*eedge,
-		  loc_info_to));
+		  loc_info_to,
+		  nullptr));
 	  }
       }
   }
@@ -333,11 +348,9 @@ get_in_edge_back_edge (const exploded_node &enode)
       const superedge *sedge = in_edge->m_sedge;
       if (!sedge)
 	continue;
-      const cfg_superedge *cfg_sedge = sedge->dyn_cast_cfg_superedge ();
-      if (!cfg_sedge)
-	continue;
-      if (cfg_sedge->back_edge_p ())
-	return in_edge;
+      if (::edge cfg_in_edge = sedge->get_any_cfg_edge ())
+	if (cfg_in_edge->flags & EDGE_DFS_BACK)
+	  return in_edge;
     }
   return nullptr;
 }
@@ -458,9 +471,17 @@ starts_infinite_loop_p (const exploded_node &enode,
       visited.add (iter);
       if (first_loc == UNKNOWN_LOCATION)
 	{
-	  location_t enode_loc = iter->get_point ().get_location ();
-	  if (enode_loc != UNKNOWN_LOCATION)
-	    first_loc = enode_loc;
+	  auto snode = iter->get_supernode ();
+	  gcc_assert (snode);
+	  /* Ignore initial location in loop if it's a merger node,
+	     to avoid using locations of phi nodes that are at the end
+	     of the loop in the source.  */
+	  if (!(iter == &enode && snode->m_state_merger_node))
+	    {
+	      location_t enode_loc = snode->get_location ();
+	      if (useful_location_p (enode_loc))
+		first_loc = enode_loc;
+	    }
 	}
 
       /* Find the out-edges that are feasible, given the
@@ -555,8 +576,6 @@ exploded_graph::detect_infinite_loops ()
       if (std::unique_ptr<infinite_loop> inf_loop
 	    = starts_infinite_loop_p (*enode, *this, get_logger ()))
 	{
-	  const supernode *snode = enode->get_supernode ();
-
 	  if (get_logger ())
 	    get_logger ()->log ("EN: %i from starts_infinite_loop_p",
 				enode->m_index);
@@ -573,10 +592,13 @@ exploded_graph::detect_infinite_loops ()
 	      continue;
 	    }
 
-	  pending_location ploc (enode, snode, inf_loop->m_loc);
+	  pending_location ploc (enode, inf_loop->m_loc);
 	  auto d
 	    = std::make_unique<infinite_loop_diagnostic> (std::move (inf_loop));
-	  get_diagnostic_manager ().add_diagnostic (ploc, std::move (d));
+	  get_diagnostic_manager ().add_diagnostic (std::move (ploc),
+						    std::move (d));
 	}
     }
 }
+
+#endif
diff --git a/gcc/analyzer/infinite-recursion.cc b/gcc/analyzer/infinite-recursion.cc
index cde3016b444..1578cd6a0af 100644
--- a/gcc/analyzer/infinite-recursion.cc
+++ b/gcc/analyzer/infinite-recursion.cc
@@ -177,7 +177,7 @@ public:
     emission_path->add_event
       (std::make_unique<warning_event>
        (event_loc_info (m_new_entry_enode->get_supernode
-			  ()->get_start_location (),
+			  ()->get_location (),
 			m_callee_fndecl,
 			m_new_entry_enode->get_stack_depth ()),
 	enode,
@@ -187,8 +187,7 @@ public:
   /* Reject paths in which conjured svalues have affected control flow
      since m_prev_entry_enode.  */
 
-  bool check_valid_fpath_p (const feasible_node &final_fnode,
-			    const gimple *)
+  bool check_valid_fpath_p (const feasible_node &final_fnode)
     const final override
   {
     /* Reject paths in which calls with unknown side effects have occurred
@@ -245,18 +244,20 @@ private:
     const superedge *sedge = eedge->m_sedge;
     if (!sedge)
       return false;
-    const cfg_superedge *cfg_sedge = sedge->dyn_cast_cfg_superedge ();
-    if (!cfg_sedge)
+    auto op = sedge->get_op ();
+    if (!op)
       return false;
-    const gimple *last_stmt = sedge->m_src->get_last_stmt ();
-    if (!last_stmt)
+    const control_flow_op *ctrlflow_op = op->dyn_cast_control_flow_op ();
+    if (!ctrlflow_op)
       return false;
 
+    const gimple &last_stmt = ctrlflow_op->get_ctrlflow_stmt ();
+
     const feasible_node *dst_fnode
       = static_cast<const feasible_node *> (fedge->m_dest);
     const region_model &model = dst_fnode->get_state ().get_model ();
 
-    if (const gcond *cond_stmt = dyn_cast <const gcond *> (last_stmt))
+    if (const gcond *cond_stmt = dyn_cast <const gcond *> (&last_stmt))
       {
 	if (expr_uses_conjured_svalue_p (model, gimple_cond_lhs (cond_stmt)))
 	  return true;
@@ -264,7 +265,7 @@ private:
 	  return true;
       }
     else if (const gswitch *switch_stmt
-	       = dyn_cast <const gswitch *> (last_stmt))
+	       = dyn_cast <const gswitch *> (&last_stmt))
       {
 	if (expr_uses_conjured_svalue_p (model,
 					 gimple_switch_index (switch_stmt)))
@@ -304,8 +305,7 @@ private:
   const checker_event *m_prev_entry_event;
 };
 
-/* Return true iff ENODE is the PK_BEFORE_SUPERNODE at a function
-   entrypoint.  */
+/* Return true iff ENODE is at a function entrypoint.  */
 
 static bool
 is_entrypoint_p (exploded_node *enode)
@@ -314,12 +314,7 @@ is_entrypoint_p (exploded_node *enode)
   const supernode *snode = enode->get_supernode ();
   if (!snode)
     return false;
-  if (!snode->entry_p ())
-    return false;;
-  const program_point &point = enode->get_point ();
-  if (point.get_kind () != PK_BEFORE_SUPERNODE)
-    return false;
-  return true;
+  return snode->entry_p ();
 }
 
 /* Walk backwards through the eg, looking for the first
@@ -618,16 +613,10 @@ exploded_graph::detect_infinite_recursion (exploded_node *enode)
 
   /* Otherwise, the state of memory is effectively the same between the two
      recursion levels; warn.  */
-
-  const supernode *caller_snode = call_string.get_top_of_stack ().m_caller;
-  const supernode *snode = enode->get_supernode ();
-  gcc_assert (caller_snode->m_returning_call);
   pending_location ploc (enode,
-			 snode,
-			 caller_snode->m_returning_call,
-			 nullptr);
+			 call_string.get_top_of_stack ().get_call_stmt ().location);
   get_diagnostic_manager ().add_diagnostic
-    (ploc,
+    (std::move (ploc),
      std::make_unique<infinite_recursion_diagnostic> (prev_entry_enode,
 						      enode,
 						      fndecl));
diff --git a/gcc/analyzer/kf-lang-cp.cc b/gcc/analyzer/kf-lang-cp.cc
index 01a98b0163e..ffd1e53b667 100644
--- a/gcc/analyzer/kf-lang-cp.cc
+++ b/gcc/analyzer/kf-lang-cp.cc
@@ -77,6 +77,26 @@ public:
       && POINTER_TYPE_P (cd.get_arg_type (1)));
   }
 
+  void
+  check_any_preconditions (const call_details &cd) const final override
+  {
+    region_model_context *ctxt = cd.get_ctxt ();
+    if (!ctxt)
+      return;
+    region_model *model = cd.get_model ();
+    const gcall &call = cd.get_call_stmt ();
+
+    /* If the call was actually a placement new, check that accessing
+       the buffer lhs is placed into does not result in out-of-bounds.  */
+    if (is_placement_new_p (call))
+      {
+	if (const region *sized_reg = get_sized_region_for_placement_new (cd))
+	  model->check_region_for_write (sized_reg,
+					 nullptr,
+					 ctxt);
+      }
+  }
+
   void impl_call_pre (const call_details &cd) const final override
   {
     region_model *model = cd.get_model ();
@@ -85,25 +105,16 @@ public:
     region_model_context *ctxt = cd.get_ctxt ();
     const gcall &call = cd.get_call_stmt ();
 
-    /* If the call was actually a placement new, check that accessing
-       the buffer lhs is placed into does not result in out-of-bounds.  */
     if (is_placement_new_p (call))
       {
 	const region *ptr_reg = cd.deref_ptr_arg (1);
 	if (ptr_reg && cd.get_lhs_type ())
-	  {
-	    const svalue *num_bytes_sval = cd.get_arg_svalue (0);
-	    const region *sized_new_reg
-		= mgr->get_sized_region (ptr_reg,
-					 cd.get_lhs_type (),
-					 num_bytes_sval);
-	    model->check_region_for_write (sized_new_reg,
-					   nullptr,
-					   ctxt);
-	    const svalue *ptr_sval
-	      = mgr->get_ptr_svalue (cd.get_lhs_type (), sized_new_reg);
-	    cd.maybe_set_lhs (ptr_sval);
-	  }
+	  if (const region *sized_reg = get_sized_region_for_placement_new (cd))
+	    {
+	      const svalue *ptr_sval
+		= mgr->get_ptr_svalue (cd.get_lhs_type (), sized_reg);
+	      cd.maybe_set_lhs (ptr_sval);
+	    }
       }
     /* If the call is an allocating new, then create a heap allocated
        region.  */
@@ -138,6 +149,22 @@ public:
 	model->add_constraint (result, NE_EXPR, null_sval, ctxt);
       }
   }
+
+private:
+  const region *
+  get_sized_region_for_placement_new (const call_details &cd) const
+  {
+    const region *ptr_reg = cd.deref_ptr_arg (1);
+    if (ptr_reg && cd.get_lhs_type ())
+      {
+	region_model_manager *mgr = cd.get_manager ();
+	const svalue *num_bytes_sval = cd.get_arg_svalue (0);
+	return mgr->get_sized_region (ptr_reg,
+				      cd.get_lhs_type (),
+				      num_bytes_sval);
+      }
+    return nullptr;
+  }
 };
 
 /* Handler for "operator delete" and for "operator delete []",
